<template>
  <Dropdown
    v-model="menuItems"
    class="text-sm"
  >
    <template #default="{ toggle, shown }">
      <Button
        :shown="shown"
        @toggle="toggle"
      />
    </template>
  </Dropdown>
</template>

<script lang="ts" setup>
import { Dropdown } from '~shared/ui';
import Button from './Button.vue';
import { icons } from '~shared/libs';
import { useTasksStore } from '~stores/tasks';
import { type ITask } from '~/entities/tasks';
import { type IDropdownElem } from '~/shared/model';

const props = defineProps<{
  task: ITask;
}>();

const taskId = props.task.id;
const { removeTaskWithChildren, addTask, removeCompletedChildredTasks } =
  useTasksStore();
const menuItems = [
  {
    title: 'add task to list',
    icon: icons.addListIcon,
    action: () => addTask({ parent: taskId } as ITask),
  },
  {
    title: 'remove list',
    icon: icons.removeListIcon,
    action: () => removeTaskWithChildren(taskId),
  },
  {
    title: 'remove completed tasks',
    icon: icons.addListIcon,
    action: () => removeCompletedChildredTasks(taskId),
  },
] as IDropdownElem[];
</script>
